// HPCSE I: Example of MPI_Barrier() and how you can get a deadlock
#include <stdio.h>
#include <mpi.h>

int main(int argc, char *argv[])
{
	MPI_Init(&argc, &argv);
    
	int rank;
	MPI_Comm_rank(MPI_COMM_WORLD, &rank);
    
	if (rank % 2 == 0) {
		// do something
		MPI_Barrier(MPI_COMM_WORLD);
	}
	else {
		// do something else
		// MPI_Barrier(MPI_COMM_WORLD); // activate the call to avoid the deadlock - too obvious ;)
	}
    
	MPI_Finalize();
	return 0;
}
