// HPCSE I: MPI_bcast()
#include <mpi.h>
#include <stdio.h>
#include <unistd.h>

int main(int argc, char** argv)
{
        MPI_Init(&argc, &argv);

        int rank, size;
        MPI_Comm_rank(MPI_COMM_WORLD, &rank);
        MPI_Comm_size(MPI_COMM_WORLD, &size);

	unsigned long nterms = 0;

	if (rank == 0) nterms = 100000000;

	MPI_Bcast(&nterms, 1, MPI_UNSIGNED_LONG, 0, MPI_COMM_WORLD);

	printf("rank %d: nterms = %ld\n", rank, nterms);

	MPI_Finalize();

	return 0;
}
