#include <stdio.h>
#include <mpi.h>
#include <unistd.h>

int main(int argc, char** argv)
{
  printf("Hello world from process %d\n", getpid());

	MPI_Init(&argc, &argv);

	int rank;
	int size;

	MPI_Comm_rank(MPI_COMM_WORLD,&rank);
	MPI_Comm_size(MPI_COMM_WORLD,&size);

	printf("I am rank %d of %d\n", rank, size);

	MPI_Finalize();


	return 0;
}
