#include "sendrecv.h"  // ACT_SEND, ACT_RECV

void sendrecv(double *data, int rank, int action)
{
	static double buffer_data;
	static int buffer_ready;

	if (action == ACT_SEND) 
	{

		#pragma omp critical
		{
		buffer_data = *data;
		buffer_ready = 1;
		}
	}
	else	// ACT_RECV
	{
		while (buffer_ready != 1) ;
		*data = buffer_data;
	}
}
 
void sendto(double *x, int rank)
{
	sendrecv(x, rank, ACT_SEND);
}

void recvfrom(double *y, int rank)
{
	sendrecv(y, rank, ACT_RECV);
}
